/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/rmp440-genom3/work/templates/ros/client/ros/rmp440_ros/msg/GyroGoal.msg
 *
 */


#ifndef RMP440_ROS_MESSAGE_GYROGOAL_H
#define RMP440_ROS_MESSAGE_GYROGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <rmp440_ros/rmp440_gyro_params.h>

namespace rmp440_ros
{
template <class ContainerAllocator>
struct GyroGoal_
{
  typedef GyroGoal_<ContainerAllocator> Type;

  GyroGoal_()
    : params()  {
    }
  GyroGoal_(const ContainerAllocator& _alloc)
    : params(_alloc)  {
    }



   typedef  ::rmp440_ros::rmp440_gyro_params_<ContainerAllocator>  _params_type;
  _params_type params;




  typedef boost::shared_ptr< ::rmp440_ros::GyroGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rmp440_ros::GyroGoal_<ContainerAllocator> const> ConstPtr;

}; // struct GyroGoal_

typedef ::rmp440_ros::GyroGoal_<std::allocator<void> > GyroGoal;

typedef boost::shared_ptr< ::rmp440_ros::GyroGoal > GyroGoalPtr;
typedef boost::shared_ptr< ::rmp440_ros::GyroGoal const> GyroGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rmp440_ros::GyroGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rmp440_ros::GyroGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rmp440_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'rmp440_ros': ['rmp440_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rmp440_ros::GyroGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rmp440_ros::GyroGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rmp440_ros::GyroGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "6ebe6bc996863c26e9d29c7e1441adc7";
  }

  static const char* value(const ::rmp440_ros::GyroGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x6ebe6bc996863c26ULL;
  static const uint64_t static_value2 = 0xe9d29c7e1441adc7ULL;
};

template<class ContainerAllocator>
struct DataType< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rmp440_ros/GyroGoal";
  }

  static const char* value(const ::rmp440_ros::GyroGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# service Gyro\n\
rmp440_gyro_params params\n\
\n\
================================================================================\n\
MSG: rmp440_ros/rmp440_gyro_params\n\
# IDL struct ::rmp440::gyro_params\n\
rmp440_gyro_mode mode\n\
string port\n\
GYRO_TYPE type\n\
float64 latitude\n\
float64 woffset\n\
\n\
================================================================================\n\
MSG: rmp440_ros/rmp440_gyro_mode\n\
# IDL enum ::rmp440::gyro_mode\n\
uint32 rmp440_gyro_off = 0\n\
uint32 rmp440_gyro_on_if_motion = 1\n\
uint32 rmp440_gyro_on = 2\n\
\n\
uint32 value\n\
\n\
================================================================================\n\
MSG: rmp440_ros/GYRO_TYPE\n\
# IDL enum ::GYRO_TYPE\n\
uint32 GYRO_UNKNOWN = 0\n\
uint32 GYRO_KVH_ECORE_1000 = 1\n\
uint32 GYRO_KVH_DSP_5000 = 2\n\
uint32 GYRO_KVH_DSP_3000 = 3\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::rmp440_ros::GyroGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.params);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct GyroGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rmp440_ros::GyroGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rmp440_ros::GyroGoal_<ContainerAllocator>& v)
  {
    s << indent << "params: ";
    s << std::endl;
    Printer< ::rmp440_ros::rmp440_gyro_params_<ContainerAllocator> >::stream(s, indent + "  ", v.params);
  }
};

} // namespace message_operations
} // namespace ros

#endif // RMP440_ROS_MESSAGE_GYROGOAL_H
