/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/rmp440-genom3/work/templates/ros/client/ros/rmp440_ros/msg/rmp440_var_params.msg
 *
 */


#ifndef RMP440_ROS_MESSAGE_RMP440_VAR_PARAMS_H
#define RMP440_ROS_MESSAGE_RMP440_VAR_PARAMS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rmp440_ros
{
template <class ContainerAllocator>
struct rmp440_var_params_
{
  typedef rmp440_var_params_<ContainerAllocator> Type;

  rmp440_var_params_()
    : coeffLin(0.0)
    , coeffAng(0.0)
    , coeffLinAng(0.0)  {
    }
  rmp440_var_params_(const ContainerAllocator& _alloc)
    : coeffLin(0.0)
    , coeffAng(0.0)
    , coeffLinAng(0.0)  {
    }



   typedef double _coeffLin_type;
  _coeffLin_type coeffLin;

   typedef double _coeffAng_type;
  _coeffAng_type coeffAng;

   typedef double _coeffLinAng_type;
  _coeffLinAng_type coeffLinAng;




  typedef boost::shared_ptr< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> const> ConstPtr;

}; // struct rmp440_var_params_

typedef ::rmp440_ros::rmp440_var_params_<std::allocator<void> > rmp440_var_params;

typedef boost::shared_ptr< ::rmp440_ros::rmp440_var_params > rmp440_var_paramsPtr;
typedef boost::shared_ptr< ::rmp440_ros::rmp440_var_params const> rmp440_var_paramsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rmp440_ros::rmp440_var_params_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rmp440_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'rmp440_ros': ['rmp440_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
{
  static const char* value()
  {
    return "29b4a8daed77f38331ffd590a5b6700d";
  }

  static const char* value(const ::rmp440_ros::rmp440_var_params_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x29b4a8daed77f383ULL;
  static const uint64_t static_value2 = 0x31ffd590a5b6700dULL;
};

template<class ContainerAllocator>
struct DataType< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rmp440_ros/rmp440_var_params";
  }

  static const char* value(const ::rmp440_ros::rmp440_var_params_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::rmp440::var_params\n\
float64 coeffLin\n\
float64 coeffAng\n\
float64 coeffLinAng\n\
";
  }

  static const char* value(const ::rmp440_ros::rmp440_var_params_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.coeffLin);
      stream.next(m.coeffAng);
      stream.next(m.coeffLinAng);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct rmp440_var_params_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rmp440_ros::rmp440_var_params_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rmp440_ros::rmp440_var_params_<ContainerAllocator>& v)
  {
    s << indent << "coeffLin: ";
    Printer<double>::stream(s, indent + "  ", v.coeffLin);
    s << indent << "coeffAng: ";
    Printer<double>::stream(s, indent + "  ", v.coeffAng);
    s << indent << "coeffLinAng: ";
    Printer<double>::stream(s, indent + "  ", v.coeffLinAng);
  }
};

} // namespace message_operations
} // namespace ros

#endif // RMP440_ROS_MESSAGE_RMP440_VAR_PARAMS_H
